var builder = WebApplication.CreateBuilder(args);
var myAllowSpecificOrigins = "_myAllowSpecificOrigins";
//builder.Services.AddDbContext<DatabaseHandler>(options => options.UseMySql(connection, ServerVersion.Create(new Version(8, 0, 35), ServerType.MySql)));
builder.Services.AddRazorPages();
builder.Services.AddCors(options =>
{
    options.AddPolicy(name: myAllowSpecificOrigins, policy  => { policy.WithOrigins("*"); });
});
var app = builder.Build();
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Error");
    // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
    app.UseHsts();
}
app.UseStatusCodePagesWithReExecute("/errors/{0}");
app.UseHttpsRedirection();
app.UseCors(myAllowSpecificOrigins);
app.UseStaticFiles(new StaticFileOptions
{
    ServeUnknownFileTypes = true
});

// app.MapGet("/api/users", API.GetUsers); //WORKS
// app.MapGet("/api/users/{id:int}", API.GetUserById); //WORKS
// app.MapGet("/api/users/nickname/{name}", API.GetUserByName); //WORKS
// app.MapDelete("/api/users/{id:int}", API.DeleteUser); //WORKS
// app.MapPost("/api/users", API.PostNewUser); //WORKS
app.MapGet("/mctaylors", (HttpContext aaa) => aaa.Response.Redirect("/errors/302"));
app.MapGet("/octol1ttle", (HttpContext aaa) => aaa.Response.Redirect("/errors/409"));

app.UseRouting();
app.UseAuthorization();
app.MapRazorPages();
app.Run();






